"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InjectChatClient = void 0;
const common_1 = require("@nestjs/common");
const constants_1 = require("../constants");
/**
 * Injects `ChatClient` instance imported from `@twurple/chat`.
 *
 * @example
 * ```ts
 * import { ChatClient } from '@twurple/chat';
 *
 * @Injectable()
 * export class CustomProvider {
 *     constructor(@InjectChatClient() private readonly _chatClient: ChatClient) {}
 * }
 */
const InjectChatClient = () => (0, common_1.Inject)(constants_1.TWURPLE_CHAT_CLIENT);
exports.InjectChatClient = InjectChatClient;
