import { type DynamicModule } from '@nestjs/common';
import { type TwurpleChatModuleAsyncOptions, type TwurpleChatModuleOptions } from './interfaces/twurple-chat-module-options.interface';
/**
 * Twurple chat client module.
 *
 * The module must be registered using either `register` or `registerAsync` static methods.
 */
export declare class TwurpleChatModule {
    /**
     * Registers the module synchronously by direct options passing.
     *
     * @param options Twurple chat module options.
     */
    static register(options?: TwurpleChatModuleOptions): DynamicModule;
    /**
     * Registers the module asynchronously using one of the following factories: "useFactory", "useExisting", or
     * "useClass".
     *
     * @param options Twurple chat module async options.
     */
    static registerAsync(options: TwurpleChatModuleAsyncOptions): DynamicModule;
    private static _createOptionsProvider;
    private static _createAsyncOptionsProviders;
    private static _createAsyncOptionsProvider;
    private static _createChatClientProvider;
}
//# sourceMappingURL=twurple-chat.module.d.ts.map