"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var TwurpleChatModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.TwurpleChatModule = void 0;
const common_1 = require("@nestjs/common");
const chat_1 = require("@twurple/chat");
const constants_1 = require("./constants");
/**
 * Twurple chat client module.
 *
 * The module must be registered using either `register` or `registerAsync` static methods.
 */
let TwurpleChatModule = exports.TwurpleChatModule = TwurpleChatModule_1 = class TwurpleChatModule {
    /**
     * Registers the module synchronously by direct options passing.
     *
     * @param options Twurple chat module options.
     */
    static register(options = {}) {
        const chatClientProvider = TwurpleChatModule_1._createChatClientProvider();
        return {
            global: options.isGlobal,
            module: TwurpleChatModule_1,
            providers: [TwurpleChatModule_1._createOptionsProvider(options), chatClientProvider],
            exports: [chatClientProvider]
        };
    }
    /**
     * Registers the module asynchronously using one of the following factories: "useFactory", "useExisting", or
     * "useClass".
     *
     * @param options Twurple chat module async options.
     */
    static registerAsync(options) {
        const chatClientProvider = TwurpleChatModule_1._createChatClientProvider();
        return {
            global: options.isGlobal,
            module: TwurpleChatModule_1,
            imports: options.imports,
            providers: [...TwurpleChatModule_1._createAsyncOptionsProviders(options), chatClientProvider],
            exports: [chatClientProvider]
        };
    }
    static _createOptionsProvider(options) {
        return {
            provide: constants_1.TWURPLE_CHAT_OPTIONS,
            useValue: options
        };
    }
    static _createAsyncOptionsProviders(options) {
        var _a;
        if ((_a = options.useExisting) !== null && _a !== void 0 ? _a : options.useFactory) {
            return [TwurpleChatModule_1._createAsyncOptionsProvider(options)];
        }
        return [
            TwurpleChatModule_1._createAsyncOptionsProvider(options),
            {
                provide: options.useClass,
                useClass: options.useClass
            }
        ];
    }
    static _createAsyncOptionsProvider(options) {
        var _a, _b;
        if (options.useFactory) {
            return {
                provide: constants_1.TWURPLE_CHAT_OPTIONS,
                inject: (_a = options.inject) !== null && _a !== void 0 ? _a : [],
                useFactory: options.useFactory
            };
        }
        return {
            provide: constants_1.TWURPLE_CHAT_OPTIONS,
            inject: [(_b = options.useExisting) !== null && _b !== void 0 ? _b : options.useClass],
            useFactory: (factory) => __awaiter(this, void 0, void 0, function* () { return yield factory.createTwurpleChatOptions(); })
        };
    }
    static _createChatClientProvider() {
        return {
            provide: constants_1.TWURPLE_CHAT_CLIENT,
            inject: [constants_1.TWURPLE_CHAT_OPTIONS],
            useFactory: (options) => new chat_1.ChatClient(options)
        };
    }
};
exports.TwurpleChatModule = TwurpleChatModule = TwurpleChatModule_1 = __decorate([
    (0, common_1.Module)({})
], TwurpleChatModule);
